# This file was auto-generated by Fern from our API Definition.

import typing

import httpx


class BaseClientWrapper:
    def __init__(self, *, api_key_id: str, api_key_secret: str, base_url: str):
        self._api_key_id = api_key_id
        self.api_key_secret = api_key_secret
        self._base_url = base_url

    def get_headers(self) -> typing.Dict[str, str]:
        headers: typing.Dict[str, str] = {
            "X-Fern-Language": "Python",
            "X-Fern-SDK-Name": "fern-balkan-id",
            "X-Fern-SDK-Version": "0.0.10",
        }
        headers["X-API-KEY-ID"] = self._api_key_id
        headers["X-API-KEY-SECRET"] = self.api_key_secret
        return headers

    def get_base_url(self) -> str:
        return self._base_url


class SyncClientWrapper(BaseClientWrapper):
    def __init__(self, *, api_key_id: str, api_key_secret: str, base_url: str, httpx_client: httpx.Client):
        super().__init__(api_key_id=api_key_id, api_key_secret=api_key_secret, base_url=base_url)
        self.httpx_client = httpx_client


class AsyncClientWrapper(BaseClientWrapper):
    def __init__(self, *, api_key_id: str, api_key_secret: str, base_url: str, httpx_client: httpx.AsyncClient):
        super().__init__(api_key_id=api_key_id, api_key_secret=api_key_secret, base_url=base_url)
        self.httpx_client = httpx_client
